标签:
http://acm.hdu.edu.cn/showproblem.php?pid=4296
Problem Description
Have you ever heard the story of Blue.Mary, the great civil engineer? Unlike Mr. Wolowitz, Dr. Blue.Mary has accomplished many great projects, one of which is the Guanghua Building.
The public opinion is that Guanghua Building is nothing more than one of hundreds of modern skyscrapers recently built in Shanghai, and sadly, they are all wrong. Blue.Mary the great civil engineer had try a completely new evolutionary building method in
project of Guanghua Building. That is, to build all the floors at first, then stack them up forming a complete building.
Believe it or not, he did it (in secret manner). Now you are face the same problem Blue.Mary once stuck in: Place floors in a good way.
Each floor has its own weight wi and strength si. When floors are stacked up, each floor has PDV(Potential Damage Value) equal to (Σwj)-si, where (Σwj) stands for sum of weight of all floors above.
Blue.Mary, the great civil engineer, would like to minimize PDV of the whole building, denoted as the largest PDV of all floors.
Now, it’s up to you to calculate this value.
Input
There’re several test cases.
In each test case, in the first line is a single integer N (1 <= N <= 105) denoting the number of building’s floors. The following N lines specify the floors. Each of them contains two integers wi and si (0 <= wi,
si <= 100000) separated by single spaces.
Please process until EOF (End Of File).
Output
For each test case, your program should output a single integer in a single line - the minimal PDV of the whole building.
If no floor would be damaged in a optimal configuration (that is, minimal PDV is non-positive) you should output 0.
Sample Input
3
10 6
2 3
5 4
2
2 2
2 2
3
10 3
2 5
3 3
Sample Output
/**
hdu 4292 贪心
题目大意:有n个板,每个板有重量x和强度y两个属性,把板叠在一起,对于每个板有个PDV值,计算方式为这个板上面的板的重量和减去这个板的强度,
对于每种叠放方式,取这个叠放方式中所以板中PDV值最大的值为代表值,问所有叠放方式中最小的代表值为多少。
解题思路:我们先考虑只有两个板的情况。pdv不能为负
1)a在上:两块的pdv分别-ay和ax-by,最大值为0或ax-by;
2)b在上:两块的pdv分别-by和bx-ay,最大值为0或bx-ay。
就可以认为两种情况的最大值分别为ax-by和bx-ay,
若1优于2则ax-by<bx-ay。因此我们按照此规则排序,然后处理出来最大值即为答案
*/
#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <iostream>
using namespace std;
const int maxn=100005;
typedef long long LL;
struct note
{
int x,y;
bool operator < (const note &other)const
{
return x+y<other.x+other.y;
}
}a[maxn];
int n,sum;
int main()
{
while(~scanf("%d",&n))
{
for(int i=0;i<n;i++)
{
scanf("%d%d",&a[i].x,&a[i].y);
}
sort(a,a+n);
LL maxx=-0x3f3f3f3f,sum=0;
for(int i=0;i<n;i++)
{
maxx=max(maxx,sum-a[i].y);
sum+=a[i].x;
}
if(maxx<0) maxx=0;
printf("%I64d\n",maxx);
}
return 0;
}
hdu 4292 贪心
标签:
原文地址:http://blog.csdn.net/lvshubao1314/article/details/44917733